sub dbconnect {

        $db = "dbi:mysql:test";
        $dbh1 = DBI->connect( $db, $dbusername, $dbpassword ) or die("DB ERROR : $!");
        $dbh2 = DBI->connect( $db, $dbusername, $dbpassword ) or die("DB ERROR : $!");

}

sub decode {

        if ( $ENV{'REQUEST_METHOD'} =~ /get/i ) { $buffer = $ENV{'QUERY_STRING'}; }
        else { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }

        @pairs = split(/&/, $buffer);
        
        foreach $pair (@pairs) {
	
                ($name, $value) = split(/=/, $pair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                $value =~ s/\n/ /g;      # added to strip line breaks 
                $value =~ s/\r//g;
                $value =~ s/\cM//g;
                $FORM{$name} = $value;
		
        }
	
	# SECURITY SECTION - Make Sure we Get what we expect
	# You will have to put your own rules here. I just include those
	# that are obvious
	$action = 0;	# set default action
	if ( $FORM{'action'} ) {

		$FORM{'action'} =~ /(\d+)/;
		$action = $1;
	
	} 
	if ( $FORM{'username'} ) {
	
		if ( length( $FORM{'username'} ) > 15 ) {
		
			printerr( "Username should never exceed 15 characters.\n" );
			exit;
		
		} 
		$FORM{'username'} =~ /^(\w+)/;
		$username = $1;
	
	}
	if ( $FORM{'password'} ) {
	
		# make sure there are no nasty characters here...
		$FORM{'password'} =~ /^(\w+)/;
		$password = $1;
	
	}
	if ( $FORM{'password1'} ) {
	
		# make sure there are no nasty characters here...
		$FORM{'password1'} =~ /^(\w+)/;
		$password1 = $1;
	
	}
	if ( $FORM{'password2'} ) {
	
		# make sure there are no nasty characters here...
		$FORM{'password2'} =~ /^(\w+)/;
		$password2 = $1;
	
	}
	if ( $FORM{'email'} ) {
	
		$email = $FORM{'email'};
		
		# NOTE: You may need to do some more e-mail validation here. Use your fav regexp.
	
	}
	if ( $FORM{'checksum'} ) {
	
		if ( ( length( $FORM{'checksum'} ) < 32 ) || ( length( $FORM{'checksum'} ) > 32 ) ) {
		
			# invalid length - error
			printerr( "Invalid checksum [1]\n" );
			exit;
		
		} elsif ( $FORM{'checksum'} =~ /\W/ ) {
		
			printerr( "Invalid checksum [2]\n" );
			exit;
		
		}
		
		$checksum = $FORM{'checksum'};
	
	}
	
}

sub checkcookie {

	if ( $ENV{'SCRIPT_NAME'} =~ /login\.pl$/ ) {
	
		# do nothing
		
	} else {

		# set initial var's
		$cookiecount = 0;
		$loggedin = 0;
		$userid = "";	# encoded userid
	
		# first get the encrypted values from the db
		$sql = "SELECT var,value FROM encryptedvars";
		$sth1 = $dbh1->prepare( $sql );
		$rv1 = $sth1->execute();
		if ( $rv1 =~ /^0E0/ ) {
	
			printerr( "Error getting data from the DB [1]\n" );
	
		} else {
	
			while ( ( $var, $val ) = $sth1->fetchrow_array() ) {
		
				if ( $var =~ /^userid/ ) { $useridvar = $val; }
				if ( $var =~ /^sessionid/ ) { $sessionid = $val; }
			
			}
	
		}

		$userid = "";
		$cdata = $ENV{'HTTP_COOKIE'};
		@cookies = split( /;/, $cdata );
		foreach $i ( @cookies ) {
	
			( $cname, $cval ) = split( /=/, $i );
			if ( $cname =~ /$useridvar/i ) {
		
				# decode the userid
				$userid = $cval;
				$cookies{'userid'} = $cval;
				$cookiecount++;	
			
				# did the session for this user expire?
				$sessionid = 0;
				$sessionage = 0;
				$sql = "SELECT sessionid,UNIX_TIMESTAMP(sessionactivity) FROM users WHERE uidencoded = '$userid' LIMIT 0,1";
				$sth1 = $dbh1->prepare( $sql );
				$rv1 = $sth1->execute();
				if ( $rv1 =~ /^0E0/ ) {
			
					printerr( "Error getting data from the DB [2]\n" );
					exit;
			
				} else {
			
					while ( ( $sessionid1,$sessiontimestamp1 ) = $sth1->fetchrow_array() ) {
				
						if ( ( $sessionid1 =~ /null/i ) || ( $sessionid eq "" ) ) {
					
							# user not logged in - do nothing
					
						} else {
					
							# was logged in - did we expire?
							$now = time;
							if ( ( $now > $sessiontimestamp1 ) && ( ( $now - $sessiontimestamp1 ) < 900 ) ) {
						
								$loggedin = 1;	# user still loged in.
							
								# now update seesion timestamp in DB
								$sql2 = "UPDATE users SET sessionid = '$sessionid1', sessionactivity = NOW() WHERE uidencoded = '$userid'";
								$dbh2->do( $sql2 );
						
							} else {
						
								# session expired - reroute to login page
								print "Location: /cgi-bin/login.pl\n\n";
								exit;
						
							}
					
						}
				
					}
			
				}
		
			}
		
			if ( $cname =~ /$sessionid/i ) {
		
				$cookies{'sessionid' } = $cval;
		
			}
	
		}
	
		if ( length( $userid ) < 2 ) {
	
			# user not logged in. 
			$loggedin = 0;
	
		}
	
	}
	
}

sub printerr {

	$message = $_[0];
	print "Content-type: text/html\n\n";
	print "<html><body><h1>Error</h1><hr><p>$message</p></body></html>";
	exit;

}

1;
